Package: BiocBaseUtils
Title: Utility and internal functions for Bioconductor packages
Version: 1.15.1
Authors@R: c(
  person("Marcel", "Ramos", , "marcel.ramos@sph.cuny.edu",
    c("aut", "cre"), c(ORCID = "0000-0002-3242-0582")
  ),
  person("Martin", "Morgan", , "martin.morgan@roswellpark.org", "ctb"
  ),
  person("Hervé", "Pagès", , "hpages.on.github@gmail.com", "ctb")
  )
Description: The package coalesces typical helper functions that are
        scattered throughout the Bioconductor ecosystem. It aims to
        reduce code redundancy by formalizing functions often used by
        Bioconductor developers. These functions include operations
        such as replacing slots in an object, selecting observations
        for show methods, labeling function life cycles, and more.
Imports: methods, utils
Depends: R (>= 4.5.0)
Suggests: knitr, rmarkdown, BiocStyle, tinytest
License: Artistic-2.0
Encoding: UTF-8
biocViews: Software, Infrastructure
BugReports: https://www.github.com/Bioconductor/BiocBaseUtils/issues
URL: https://www.github.com/Bioconductor/BiocBaseUtils
Roxygen: list(markdown = TRUE)
VignetteBuilder: knitr
Date: 2026-05-08
Config/roxygen2/version: 8.0.0
Repository: https://bioc.r-universe.dev
Date/Publication: 2026-05-08 19:02:27 UTC
RemoteUrl: https://github.com/bioc/BiocBaseUtils
RemoteRef: HEAD
RemoteSha: 481d51b6ba2e70318654e785b2b4ba84e43ddf48
NeedsCompilation: no
Packaged: 2026-05-08 21:00:14 UTC; root
Author: Marcel Ramos [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-3242-0582>),
  Martin Morgan [ctb],
  Hervé Pagès [ctb]
Maintainer: Marcel Ramos <marcel.ramos@sph.cuny.edu>
Built: R 4.6.0; ; 2026-05-08 21:01:53 UTC; unix

---
output: github_document
knit: (function(inputFile, encoding) {
  rmarkdown::render(inputFile, encoding = encoding, output_dir = "../../") })
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  cache = TRUE,
  out.width = "100%"
)
```

```{r, child="../../vignettes/BiocBaseUtils.Rmd"}

```

#' Select and return only some entries from a vector
#'
#' `selectSome` works well in `show` methods. It abbreviates a vector input
#' depending on the `maxToShow` argument.
#'
#' @param obj character() A vector to be abbreviated for display purposes
#'
#' @param maxToShow numeric(1) The maximum number of values to show in the
#'     output (default: 5)
#'
#' @param ellipsis character(1) The symbol used to abbreviate values in the
#'     vector (default: "...")
#'
#' @param ellipsisPos character(1) The location for the ellipsis in the output,
#'     by default in the `"middle"` but can be moved to either the `"end"` or
#'     the `"start"`.
#'
#' @param quote logical(1) Whether or not to add a single quote around the `obj`
#'     input. This only works for character type inputs.
#'
#' @return An abbreviated output of `obj`
#'
#' @importFrom utils head tail
#'
#' @author M. Morgan, H. Pagès
#'
#' @examples
#'
#' letters
#'
#' selectSome(letters)
#'
#' @export
selectSome <- function(obj, maxToShow = 5, ellipsis = "...",
    ellipsisPos = c("middle", "end", "start"), quote = FALSE)
{
    if (is.character(obj) && quote)
        obj <- sQuote(obj)
    ellipsisPos <- match.arg(ellipsisPos)
    len <- length(obj)
    if (maxToShow < 3)
        maxToShow <- 3
    if (len > maxToShow) {
        maxToShow <- maxToShow - 1
        if (ellipsisPos == "end") {
            c(head(obj, maxToShow), ellipsis)
        } else if (ellipsisPos == "start") {
            c(ellipsis, tail(obj, maxToShow))
        } else {
            bot <- ceiling(maxToShow/2)
            top <- len - (maxToShow - bot - 1)
            sbot <- seq_len(bot)
            nms <- obj[c(sbot, top:len)]
            c(as.character(nms[sbot]), ellipsis, as.character(nms[-sbot]))
        }
    } else {
        obj
    }
}

# adapted from S4Vectors
.isSingle <- function(x, na.ok, FUN)
{
    FUN(x) && identical(length(x), 1L) && (na.ok || !is.na(x))
}

#' @name Assertions
#'
#' @title Suite of helper functions to test for types
#'
#' @description
#' These are a group of helper functions that allow the developer
#' to easily check for common data types in Bioconductor. These include
#' logical, character, and numeric (& integer).
#'
#' @details
#' Some functions such as `isScalarCharacter` allow exceptions to the type
#' checks via the `na.ok` and `zchar` arguments. Others, for example
#' `isScalarNumber` can permit `Inf` with the `infinite.ok` argument.
#'
#' @param x The input vector whose type is to be checked
#'
#' @param na.ok logical(1L) Whether it is acceptable to consider `NA` type
#'     inputs (default: `FALSE`).
#'
#' @param zchar logical(1L) Whether is is acceptable to consider 'zero'
#'     characters as defined by `nchar`, e.g., `nchar("")` (default: `FALSE`).
#'
#' @param infinite.ok logical(1L) Whether it is acceptable to consider infinite
#'     values as identified by `is.finite` (default: `FALSE`).
#'
#' @author M. Morgan, H. Pagès
#'
#' @return Either `TRUE` or `FALSE`
#'
#' @md
#'
#' @examples
#'
#' isTRUEorFALSE(TRUE)
#' isTRUEorFALSE(FALSE)
#' isTRUEorFALSE(NA, na.ok = TRUE)
#'
#' isScalarCharacter(LETTERS)
#' isScalarCharacter("L")
#' isCharacter(LETTERS)
#' isCharacter(NA_character_, na.ok = TRUE)
#' isZeroOneCharacter("")
#' isZeroOneCharacter("", zchar = TRUE)
#'
#' isScalarInteger(1L)
#' isScalarInteger(1)
#'
#' isScalarNumber(1)
#' isScalarNumber(1:2)
#'
NULL


#' @describeIn Assertions Is the input a single logical vector?
#'
#' @export
isTRUEorFALSE <- function(x, na.ok = FALSE)
{
    .isSingle(x, na.ok, is.logical)
}

#' @describeIn Assertions Is the input a single character vector?
#'
#' @export
isScalarCharacter <- function(x, na.ok = FALSE, zchar = FALSE)
{
    identical(length(x), 1L) && isCharacter(x, na.ok, zchar)
}

#' @describeIn Assertions Is the input a single integer vector?
#'
#' @export
isScalarInteger <- function(x, na.ok = FALSE)
{
    .isSingle(x, na.ok, is.integer)
}

#' @describeIn Assertions Is the input a single numeric vector?
#'
#' @export
isScalarNumber <- function(x, na.ok = FALSE, infinite.ok = FALSE)
{
    .isSingle(x, na.ok, is.numeric) && (infinite.ok || is.finite(x))
}

#' @describeIn Assertions Is the input a single logical vector?
#'
#' @export
isScalarLogical <- function(x, na.ok = FALSE)
{
    .isSingle(x, na.ok, is.logical)
}

#' @describeIn Assertions Is the input a character vector?
#'
#' @export
isCharacter <- function(x, na.ok = FALSE, zchar = FALSE)
{
    is.character(x) && (na.ok || all(!is.na(x))) && (zchar || all(nzchar(x)))
}

#' @describeIn Assertions Is the input a character vector of zero or one length?
#'
#' @export
isZeroOneCharacter <- function(x, na.ok = FALSE, zchar = FALSE)
{
    (length(x) == 0L || length(x) == 1L) &&
        isCharacter(x, na.ok, zchar)
}

#' BiocBaseUtils: Utility and Internal functions for Bioconductor packages
#'
#' BiocBaseUtils is a package aimed at helping the typical Bioconductor developer
#' formalize often written functions that can be seen scattered throughout the
#' Bioconductor ecosystem. Some of these functions include the ability to
#' replace slots in an object. Other functions work to create a nice show method
#' output by selecting some observations.
#'
#' @aliases NULL
"_PACKAGE"

#' Check packages are installed otherwise suggest
#'
#' `checkInstalled` allows to check if a package is installed. If the package is
#' not available, a convenient copy-and-paste message is provided for package
#' installation with `BiocManager`. The function is typically used within
#' functions that check for package availability from the `Suggests` field.
#'
#' @param pkgs `character()` package names required for a function
#'
#' @return `TRUE` if all packages are installed, otherwise stops with a message
#'   and suggests installation of missing packages
#'
#' @author M. Morgan, M. Ramos
#'
#' @examples
#' if (interactive()) {
#'     checkInstalled(
#'         c("BiocParallel", "SummarizedExperiment")
#'     )
#' }
#' @export
checkInstalled <- function(pkgs) {
    inst <- vapply(pkgs, FUN = function(pkg) {
        !nzchar(system.file(package = pkg))
    }, logical(1L))
    toinst <- pkgs[inst]
    if (length(toinst))
        .install_suggestion(toinst)
    else
        TRUE
}

.install_suggestion <- function(pkgs) {
    n <- length(pkgs)
    txt <- if (identical(n, 1L)) '"%s"' else 'c(\n    "%s"\n  )'
    fmt <- '  BiocManager::install(%s)'
    fmt <- sprintf(fmt, txt)
    pkgs <- paste(strwrap(
        paste(pkgs, collapse='", "'),
        width = getOption("width") - 4L
    ), collapse="\n    ")
    cat(
        "The following package(s) are required for this function:",
        "\n\n", sprintf(fmt, pkgs), "\n\n", sep = ""
    )
    stop(
        "To use this function, install missing package dependencies.",
        call. = FALSE
    )
}

expect_error(
    checkInstalled("abc123xyzjfk"),
    "To use this function, install missing package dependencies."
)

tinytest::expect_match(
    trimws(
        capture.output(
            tryCatch({
                checkInstalled("abc123xyzjfk")
            }, error = function(e) {
                invisible()
            })
        )[3]
    ),
    "BiocManager::install\\(\\\"abc123xyzjfk\\\"\\)"
)

expect_true(
    checkInstalled(c("base", "datasets"))
)

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>"
)

## ----install, eval=FALSE------------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# BiocManager::install("BiocBaseUtils")

## ----load-package, include=TRUE, results="hide", message=FALSE, warning=FALSE----
library(BiocBaseUtils)

## ----assertions-logical-------------------------------------------------------
isTRUEorFALSE(TRUE)
isTRUEorFALSE(FALSE)
isTRUEorFALSE(NA, na.ok = TRUE)

## ----assertions-character-----------------------------------------------------
isScalarCharacter(LETTERS)
isScalarCharacter("L")
isCharacter(LETTERS)
isCharacter(NA_character_, na.ok = TRUE)
isZeroOneCharacter("")
isZeroOneCharacter("", zchar = TRUE)

## ----assertions-numeric-------------------------------------------------------
isScalarInteger(1L)
isScalarInteger(1)

isScalarNumber(1)
isScalarNumber(1:2)

## ----setslots-class-----------------------------------------------------------
setClass("A", representation = representation(slot1 = "numeric"))
aclass <- new("A", slot1 = 1:10)
aclass

## ----setslots-update----------------------------------------------------------
aclass <- setSlots(aclass, slot1 = 11:20)
aclass

## ----selectsome-show----------------------------------------------------------
setMethod("show", signature = "A", function(object) {
    s1info <- getElement(object, "slot1")
    cat("A sequence:", selectSome(s1info))
})
aclass

## ----session-info-------------------------------------------------------------
sessionInfo()

#' Convenience function to set slot values
#'
#' @aliases replaceSlots
#'
#' @description
#' Given the current object, the function `setSlots` will take name-value
#' pair inputs either as named arguments or a `list` and replace the values of
#' the specified slots. This is a convenient function for updating slots in
#' an S4 class object.
#'
#' @param object An S4 object with slots to replace
#'
#' @param ... Slot name and value pairs either as named arguments
#'     or a named list, e.g., `slotName = value`.
#'
#' @param check logical(1L) Whether to run validObject after the slot
#'     replacement
#'
#' @return The object input with updated slot data
#'
#' @importFrom methods slot<- validObject
#'
#' @author H. Pagès
#'
#' @examples
#'
#' setClass("A", representation = representation(slotA = "character"))
#'
#' aclass <- new("A", slotA = "A")
#'
#' setSlots(aclass, slotA = "B")
#'
#' @export
setSlots <- function (object, ..., check = TRUE)
{
    if (!isTRUEorFALSE(check))
        stop("'check' must be TRUE or FALSE")
    object <- unsafe_replaceSlots(object, ...)
    if (check)
        validObject(object)
    object
}

unsafe_replaceSlots <- function (object, ..., .slotList = list())
{
    slots <- c(list(...), .slotList)
    slots_names <- names(slots)
    for (i in seq_along(slots)) {
        slot_name <- slots_names[[i]]
        if (identical(slot_name, "mcols"))
            slot_name <- "elementMetadata"
        slot_val <- slots[[i]]
        slot(object, slot_name, check = FALSE) <- slot_val
    }
    object
}

#' Ask user for a yes/no response
#'
#' @param prompt `character()` Question form prompt to display to the user
#'   without a question mark
#'
#' @param interactive.only `logical(1)` If `TRUE`, the function will only
#'  prompt the user when the R session is interactive. If `FALSE`, the
#'  function will always prompt the user.
#'
#' @return TRUE when user replies with 'yes' to prompt, FALSE when 'no'
#'
#' @author Martin M.
#'
#' @examples
#'
#' askUserYesNo("Do you want to continue")
#'
#' @export
askUserYesNo <-
    function(prompt, interactive.only = TRUE)
{
    if (interactive.only && !interactive())
        return(FALSE)
    responses <- c("yes", "no")
    msg1 <- paste0(prompt, " [", paste(responses, collapse = ", "), "]? ")
    msg2 <- paste0("reply with '", paste(responses, collapse = "' or '"), "'")
    repeat {
        userResponse <- trimws(tolower(readline(msg1)))
        if (userResponse %in% responses)
            break
        message(msg2)
    }
    identical(userResponse, responses[1L])
}

#' Set the life cycle stage of a function
#'
#' @description The `lifeCycle` function is used to set the life cycle stage of
#'   a function. It is to be used within the body of the function that is being
#'   deprecated or defunct. It is a wrapper around both `.Deprecated` and
#'   `.Defunct` base R functions.
#'
#' @param newfun `character(1)` The name of the function to use instead. It can
#'   be a specific function within another package (e.g., `package::function`)
#'   or a function in the current package (e.g., `function`). If `newfun` is not
#'   specified, the calling function `oldfun` is assumed to be the replacement.
#'
#' @param newpackage `character(1)` If a function is moved to a new package, the
#'   name of the new package can be specified here. This is equivalent to
#'   specifying `newfun = paste0(newpackage, "::", newfun)`.
#'
#' @param package `character(1)` The name of the package where the deprecated
#'   or defunct function resides. It corresponds to the package from where the
#'   `lifeCycle` function is called.
#'
#' @param cycle `character(1)` The life cycle stage of the function. This can be
#'   either `"deprecated"` or `"defunct"`.
#'
#' @param title `character(1)` The Rd name prefix of the documentation page
#'   where deprecated or defunct functions are documented (e.g., "summary" for
#'   "summary-deprecated"). By default, the package name is used.
#'
#' @examples
#' test_fun <- function() {
#'     lifeCycle(newfun = "new_test", package = "BiocBaseUtils")
#' }
#' ## catch warning and convert to message
#' tryCatch(test_fun(), warning = function(w) message(w) )
#'
#' test_fun <- function() {
#'     lifeCycle(
#'         newfun = "new_test", package = "BiocBaseUtils", cycle = "defunct"
#'     )
#' }
#' ## catch error and convert to message
#' tryCatch(test_fun(), error = function(e) message(e))
#' @export
lifeCycle <- function(
    newfun = oldfun, newpackage, package,
    cycle = c("deprecated", "defunct"), title = package
) {
    removal <- missing(newfun) && missing(newpackage)
    oldfun <- as.character(sys.call(sys.parent())[1L])
    cycle <- match.arg(cycle)

    if (!missing(newpackage))
        newfun <- paste0(newpackage, "::", gsub("^.*::", "", newfun))

    msg <- c(
        gettextf("'%s' is %s.\n  ", oldfun, cycle),
        if (!removal) gettextf("Use '%s' instead.\n  ", newfun),
        gettextf("See help('%s').",  paste0(title, "-", cycle))
    )
    cycle_fun <- switch(cycle, deprecated = .Deprecated, defunct = .Defunct)
    arglist <- list(new = newfun, msg = msg, package = package)
    do.call(cycle_fun, arglist)
}

---
title: "BiocBaseUtils Quick Start"
author: "Bioconductor Core Team"
date: "`r format(Sys.time(), '%B %d, %Y')`"
output:
  BiocStyle::html_document:
    number_sections: yes
    toc: true
vignette: >
  %\VignetteIndexEntry{BiocBaseUtils Quick Start}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>"
)
```

# BiocBaseUtils

The `BiocBaseUtils` package provides a suite of helper functions designed to
help developers. Currently, it covers three topics often encountered during
the development process.

1. Assertions - Type checks for logical, character, and numeric inputs
2. Slot replacement - Replacing the value of object slots
3. `show` method - Limiting the output of internal components of a class

# Installation

Install the package directly from Bioconductor:

```{r install, eval=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("BiocBaseUtils")
```

# Load Package

```{r load-package, include=TRUE, results="hide", message=FALSE, warning=FALSE}
library(BiocBaseUtils)
```

# Assertions

We provide a number of functions that helps the developer establish the
type of class of a particular object. These include `integer`, `numeric`,
`character`, and `logical`; types often used in R / Bioconductor.

## Logical

```{r assertions-logical}
isTRUEorFALSE(TRUE)
isTRUEorFALSE(FALSE)
isTRUEorFALSE(NA, na.ok = TRUE)
```

## Character

```{r assertions-character}
isScalarCharacter(LETTERS)
isScalarCharacter("L")
isCharacter(LETTERS)
isCharacter(NA_character_, na.ok = TRUE)
isZeroOneCharacter("")
isZeroOneCharacter("", zchar = TRUE)
```

## Numeric

```{r assertions-numeric}
isScalarInteger(1L)
isScalarInteger(1)

isScalarNumber(1)
isScalarNumber(1:2)
```

# Slot replacement

This function is often used in packages that establish formal S4 classes.
When updating the value of a slot, one often uses the `setSlots` function.

```{r setslots-class}
setClass("A", representation = representation(slot1 = "numeric"))
aclass <- new("A", slot1 = 1:10)
aclass
```

Now we use the `setSlots` function to update the values in the object.

```{r setslots-update}
aclass <- setSlots(aclass, slot1 = 11:20)
aclass
```

Note that `setSlots` provides the same functionality as
`BiocGenerics:::replaceSlots` but is more consistent with Bioconductor the
setter and getter language.

# `show` method

The `selectSome` function allows the developer to display a limited amount of
information from a developed class. Note that the use of the `@` here is due
to the minimal implementation in the examples provided. The developer should
always provide an interface to access the internal components of the class
via an 'accessor' function.

```{r selectsome-show}
setMethod("show", signature = "A", function(object) {
    s1info <- getElement(object, "slot1")
    cat("A sequence:", selectSome(s1info))
})
aclass
```

# Contributing

`BiocBaseUtils` is a work in progress and we welcome contributions. There
are quite a few often-used utility functions that are yet to be included in the
package. We would like to keep the dependencies in this package minimal;
therefore, contributions should mostly use base R.

# Session Info

```{r session-info}
sessionInfo()
```

Please report minimally reproducible bugs at our [github issue page][].

[github issue page]: https://github.com/Bioconductor/BiocBaseUtils/issues

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/internals.R
\name{setSlots}
\alias{setSlots}
\alias{replaceSlots}
\title{Convenience function to set slot values}
\usage{
setSlots(object, ..., check = TRUE)
}
\arguments{
\item{object}{An S4 object with slots to replace}

\item{...}{Slot name and value pairs either as named arguments
or a named list, e.g., \code{slotName = value}.}

\item{check}{logical(1L) Whether to run validObject after the slot
replacement}
}
\value{
The object input with updated slot data
}
\description{
Given the current object, the function \code{setSlots} will take name-value
pair inputs either as named arguments or a \code{list} and replace the values of
the specified slots. This is a convenient function for updating slots in
an S4 class object.
}
\examples{

setClass("A", representation = representation(slotA = "character"))

aclass <- new("A", slotA = "A")

setSlots(aclass, slotA = "B")

}
\author{
H. Pagès
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/checkInstalled.R
\name{checkInstalled}
\alias{checkInstalled}
\title{Check packages are installed otherwise suggest}
\usage{
checkInstalled(pkgs)
}
\arguments{
\item{pkgs}{\code{character()} package names required for a function}
}
\value{
\code{TRUE} if all packages are installed, otherwise stops with a message
and suggests installation of missing packages
}
\description{
\code{checkInstalled} allows to check if a package is installed. If the package is
not available, a convenient copy-and-paste message is provided for package
installation with \code{BiocManager}. The function is typically used within
functions that check for package availability from the \code{Suggests} field.
}
\examples{
if (interactive()) {
    checkInstalled(
        c("BiocParallel", "SummarizedExperiment")
    )
}
}
\author{
M. Morgan, M. Ramos
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/assertions.R
\name{Assertions}
\alias{Assertions}
\alias{isTRUEorFALSE}
\alias{isScalarCharacter}
\alias{isScalarInteger}
\alias{isScalarNumber}
\alias{isScalarLogical}
\alias{isCharacter}
\alias{isZeroOneCharacter}
\title{Suite of helper functions to test for types}
\usage{
isTRUEorFALSE(x, na.ok = FALSE)

isScalarCharacter(x, na.ok = FALSE, zchar = FALSE)

isScalarInteger(x, na.ok = FALSE)

isScalarNumber(x, na.ok = FALSE, infinite.ok = FALSE)

isScalarLogical(x, na.ok = FALSE)

isCharacter(x, na.ok = FALSE, zchar = FALSE)

isZeroOneCharacter(x, na.ok = FALSE, zchar = FALSE)
}
\arguments{
\item{x}{The input vector whose type is to be checked}

\item{na.ok}{logical(1L) Whether it is acceptable to consider \code{NA} type
inputs (default: \code{FALSE}).}

\item{zchar}{logical(1L) Whether is is acceptable to consider 'zero'
characters as defined by \code{nchar}, e.g., \code{nchar("")} (default: \code{FALSE}).}

\item{infinite.ok}{logical(1L) Whether it is acceptable to consider infinite
values as identified by \code{is.finite} (default: \code{FALSE}).}
}
\value{
Either \code{TRUE} or \code{FALSE}
}
\description{
These are a group of helper functions that allow the developer
to easily check for common data types in Bioconductor. These include
logical, character, and numeric (& integer).
}
\details{
Some functions such as \code{isScalarCharacter} allow exceptions to the type
checks via the \code{na.ok} and \code{zchar} arguments. Others, for example
\code{isScalarNumber} can permit \code{Inf} with the \code{infinite.ok} argument.
}
\section{Functions}{
\itemize{
\item \code{isTRUEorFALSE()}: Is the input a single logical vector?

\item \code{isScalarCharacter()}: Is the input a single character vector?

\item \code{isScalarInteger()}: Is the input a single integer vector?

\item \code{isScalarNumber()}: Is the input a single numeric vector?

\item \code{isScalarLogical()}: Is the input a single logical vector?

\item \code{isCharacter()}: Is the input a character vector?

\item \code{isZeroOneCharacter()}: Is the input a character vector of zero or one length?

}}
\examples{

isTRUEorFALSE(TRUE)
isTRUEorFALSE(FALSE)
isTRUEorFALSE(NA, na.ok = TRUE)

isScalarCharacter(LETTERS)
isScalarCharacter("L")
isCharacter(LETTERS)
isCharacter(NA_character_, na.ok = TRUE)
isZeroOneCharacter("")
isZeroOneCharacter("", zchar = TRUE)

isScalarInteger(1L)
isScalarInteger(1)

isScalarNumber(1)
isScalarNumber(1:2)

}
\author{
M. Morgan, H. Pagès
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/lifecycle.R
\name{lifeCycle}
\alias{lifeCycle}
\title{Set the life cycle stage of a function}
\usage{
lifeCycle(
  newfun = oldfun,
  newpackage,
  package,
  cycle = c("deprecated", "defunct"),
  title = package
)
}
\arguments{
\item{newfun}{\code{character(1)} The name of the function to use instead. It can
be a specific function within another package (e.g., \verb{package::function})
or a function in the current package (e.g., \code{function}). If \code{newfun} is not
specified, the calling function \code{oldfun} is assumed to be the replacement.}

\item{newpackage}{\code{character(1)} If a function is moved to a new package, the
name of the new package can be specified here. This is equivalent to
specifying \code{newfun = paste0(newpackage, "::", newfun)}.}

\item{package}{\code{character(1)} The name of the package where the deprecated
or defunct function resides. It corresponds to the package from where the
\code{lifeCycle} function is called.}

\item{cycle}{\code{character(1)} The life cycle stage of the function. This can be
either \code{"deprecated"} or \code{"defunct"}.}

\item{title}{\code{character(1)} The Rd name prefix of the documentation page
where deprecated or defunct functions are documented (e.g., "summary" for
"summary-deprecated"). By default, the package name is used.}
}
\description{
The \code{lifeCycle} function is used to set the life cycle stage of
a function. It is to be used within the body of the function that is being
deprecated or defunct. It is a wrapper around both \code{.Deprecated} and
\code{.Defunct} base R functions.
}
\examples{
test_fun <- function() {
    lifeCycle(newfun = "new_test", package = "BiocBaseUtils")
}
tryCatch(
   test_fun(),
   warning = function(w) message(w)
)
test_fun <- function() {
    lifeCycle(
        newfun = "new_test", package = "BiocBaseUtils", cycle = "defunct"
    )
}
tryCatch(
   test_fun(),
   error = function(e) message(e)
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/showUtils.R
\name{selectSome}
\alias{selectSome}
\title{Select and return only some entries from a vector}
\usage{
selectSome(
  obj,
  maxToShow = 5,
  ellipsis = "...",
  ellipsisPos = c("middle", "end", "start"),
  quote = FALSE
)
}
\arguments{
\item{obj}{character() A vector to be abbreviated for display purposes}

\item{maxToShow}{numeric(1) The maximum number of values to show in the
output (default: 5)}

\item{ellipsis}{character(1) The symbol used to abbreviate values in the
vector (default: "...")}

\item{ellipsisPos}{character(1) The location for the ellipsis in the output,
by default in the \code{"middle"} but can be moved to either the \code{"end"} or
the \code{"start"}.}

\item{quote}{logical(1) Whether or not to add a single quote around the \code{obj}
input. This only works for character type inputs.}
}
\value{
An abbreviated output of \code{obj}
}
\description{
\code{selectSome} works well in \code{show} methods. It abbreviates a vector input
depending on the \code{maxToShow} argument.
}
\examples{

letters

selectSome(letters)

}
\author{
M. Morgan, H. Pagès
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BiocDeveloper-package.R
\docType{package}
\name{BiocBaseUtils-package}
\title{BiocBaseUtils: Utility and Internal functions for Bioconductor packages}
\description{
BiocBaseUtils is a package aimed at helping the typical Bioconductor developer
formalize often written functions that can be seen scattered throughout the
Bioconductor ecosystem. Some of these functions include the ability to
replace slots in an object. Other functions work to create a nice show method
output by selecting some observations.
}
\seealso{
Useful links:
\itemize{
  \item Report bugs at \url{https://www.github.com/Bioconductor/BiocBaseUtils/issues}
}

}
\author{
\strong{Maintainer}: Marcel Ramos \email{marcel.ramos@roswellpark.org} (\href{https://orcid.org/0000-0002-3242-0582}{ORCID})

Other contributors:
\itemize{
  \item Martin Morgan \email{martin.morgan@roswellpark.org} [contributor]
  \item Hervé Pagès \email{hpages.on.github@gmail.com} [contributor]
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/askUserYesNo.R
\name{askUserYesNo}
\alias{askUserYesNo}
\title{Ask user for a yes/no response}
\usage{
askUserYesNo(prompt, interactive.only = TRUE)
}
\arguments{
\item{prompt}{\code{character()} Question form prompt to display to the user
without a question mark}

\item{interactive.only}{\code{logical(1)} If \code{TRUE}, the function will only
prompt the user when the R session is interactive. If \code{FALSE}, the
function will always prompt the user.}
}
\value{
TRUE when user replies with 'yes' to prompt, FALSE when 'no'
}
\description{
Ask user for a yes/no response
}
\examples{

askUserYesNo("Do you want to continue")

}
\author{
Martin M.
}
